'use strict';

var _bignumber = require('bignumber.js');

var _bignumber2 = _interopRequireDefault(_bignumber);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * 转换为二进制字符串
 * @returns {string}
 */
var toBinString = function toBinString() {
  return this.toString(2);
};

/**
 * 转换为八进制字符串
 * @returns {string}
 */
/** @module */
var toOctString = function toOctString() {
  return this.toString(8);
};

/**
 * 转换为十进制字符串
 * @returns {string}
 */
var toDecimalString = function toDecimalString() {
  return this.toString(10);
};

/**
 * 转换为十六进制字符串
 * @returns {string}
 */
var toHexString = function toHexString() {
  return this.toString(16);
};

_bignumber2.default.prototype.toBinString = toBinString;
_bignumber2.default.prototype.toOctString = toOctString;
_bignumber2.default.prototype.toHexString = toHexString;
_bignumber2.default.prototype.toDecimalString = toDecimalString;