'use strict';

require('../index');

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('bufferAssist', function () {

  it('reverseBuffer', function () {
    var test = new Buffer('ab');
    var result = test.reverseBuffer();
    _assert2.default.strictEqual(test[0], 97); // a
    _assert2.default.strictEqual(result[0], 98); // b
  });

  it('deepCopy', function () {
    var test = new Buffer('ab');
    var result = test.deepCopy();
    result.reverse();
    _assert2.default.strictEqual(test[0], 97); // a
    _assert2.default.strictEqual(result[0], 98); // b
  });
});