'use strict';

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

/** @module */

// const test = await Promise.allKeys({
//   a: Promise.resolve(1),
//   b: {
//     c: Promise.resolve(2),
//     d: Promise.resolve(3)
//   },
//   e: {
//     f: Promise.resolve(4)
//   },
//   g: [Promise.resolve(5), Promise.resolve(6), Promise.resolve(7)]
// })
Object.defineProperty(Promise, 'allKeys', {
  configurable: true,
  writable: true,
  /**
   * 并行处理Promise, 传入对象，是对Promise.all()的补充
   * @param object
   * @returns {Promise<{}>}
   */
  value: function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(object) {
      var resolved, promises;
      return regeneratorRuntime.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              resolved = {};
              promises = Object.entries(object).map(function () {
                var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(_ref3) {
                  var _ref4 = _slicedToArray(_ref3, 2),
                      key = _ref4[0],
                      value = _ref4[1];

                  var promises1;
                  return regeneratorRuntime.wrap(function _callee2$(_context2) {
                    while (1) {
                      switch (_context2.prev = _context2.next) {
                        case 0:
                          if (!(value instanceof Promise)) {
                            _context2.next = 6;
                            break;
                          }

                          _context2.next = 3;
                          return value;

                        case 3:
                          resolved[key] = _context2.sent;
                          _context2.next = 15;
                          break;

                        case 6:
                          if (!(value instanceof Array)) {
                            _context2.next = 12;
                            break;
                          }

                          _context2.next = 9;
                          return Promise.all(value);

                        case 9:
                          resolved[key] = _context2.sent;
                          _context2.next = 15;
                          break;

                        case 12:
                          promises1 = Object.entries(value).map(function () {
                            var _ref5 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(_ref6) {
                              var _ref7 = _slicedToArray(_ref6, 2),
                                  key1 = _ref7[0],
                                  promise = _ref7[1];

                              return regeneratorRuntime.wrap(function _callee$(_context) {
                                while (1) {
                                  switch (_context.prev = _context.next) {
                                    case 0:
                                      !resolved[key] && (resolved[key] = {});
                                      _context.next = 3;
                                      return promise;

                                    case 3:
                                      resolved[key][key1] = _context.sent;

                                    case 4:
                                    case 'end':
                                      return _context.stop();
                                  }
                                }
                              }, _callee, undefined);
                            }));

                            return function (_x3) {
                              return _ref5.apply(this, arguments);
                            };
                          }());
                          _context2.next = 15;
                          return Promise.all(promises1);

                        case 15:
                        case 'end':
                          return _context2.stop();
                      }
                    }
                  }, _callee2, undefined);
                }));

                return function (_x2) {
                  return _ref2.apply(this, arguments);
                };
              }());
              _context3.next = 4;
              return Promise.all(promises);

            case 4:
              return _context3.abrupt('return', resolved);

            case 5:
            case 'end':
              return _context3.stop();
          }
        }
      }, _callee3, undefined);
    }));

    return function value(_x) {
      return _ref.apply(this, arguments);
    };
  }()
});